#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire300six4xi.py">
#<abstract4xi abstract = "fires to direction six and to distance 300"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2six4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
       
# -------------------------------------------------------------------------------------------------
# SHOT2SIX - COORDINATE SIGNS OF SHOOT2SIX4XI: (X - ,Y + ,Z - )
# -------------------------------------------------------------------------------------------------    
global shot2six3004xi



# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

shot2six3004xi = {
                1:'-101x168y-225z',
                2:'-103x265y-95z',
                3:'-107x265y-90z',
                4:'-109x161y-227z',
                5:'-116x153y-229z',
                6:'-116x258y-98z',
                7:'-120x258y-93z',
                8:'-122x145y-231z',
                9:'-128x137y-233z',
                10:'-129x251y-100z',
                11:'-133x128y-235z',
                12:'-133x250y-95z',
                13:'-138x120y-237z',
                14:'-142x111y-239z',
                15:'-142x243y-103z',
                16:'-146x102y-241z',
                17:'-146x242y-98z',
                18:'-149x93y-242z',
                19:'-14x118y-275z',
                20:'-151x5y-259z',
                21:'-152x84y-244z',
                22:'-153x13y-257z',
                23:'-153x234y-106z',
                24:'-154x21y-256z',
                25:'-154x74y-246z',
                26:'-155x30y-254z',
                27:'-155x65y-247z',
                28:'-156x38y-252z',
                29:'-156x47y-251z',
                30:'-156x56y-249z',
                31:'-157x233y-101z',
                32:'-165x225y-109z',
                33:'-169x224y-104z',
                34:'-176x215y-112z',
                35:'-180x214y-107z',
                36:'-186x204y-114z',
                37:'-189x232y0z',
                38:'-190x204y-110z',
                39:'-196x194y-117z',
                40:'-200x192y-112z',
                41:'-201x222y-3z',
                42:'-205x182y-120z',
                43:'-209x181y-115z',
                44:'-20x114y-276z',
                45:'-212x211y-6z',
                46:'-213x171y-123z',
                47:'-217x169y-118z',
                48:'-221x158y-125z',
                49:'-223x200y-9z',
                50:'-224x157y-121z',
                51:'-228x146y-128z',
                52:'-231x144y-123z',
                53:'-233x188y-12z',
                54:'-234x133y-131z',
                55:'-239x120y-133z',
                56:'-242x175y-15z',
                57:'-244x107y-136z',
                58:'-248x93y-139z',
                59:'-251x162y-18z',
                60:'-251x80y-141z',
                61:'-254x66y-144z',
                62:'-255x53y-147z',
                63:'-256x12y-154z',
                64:'-256x39y-149z',
                65:'-257x25y-152z',
                66:'-259x149y-21z',
                67:'-25x110y-277z',
                68:'-266x135y-24z',
                69:'-26x213y-209z',
                70:'-273x120y-27z',
                71:'-278x106y-30z',
                72:'-283x91y-33z',
                73:'-287x76y-36z',
                74:'-290x61y-39z',
                75:'-293x45y-42z',
                76:'-294x30y-45z',
                77:'-295x0y-51z',
                78:'-295x14y-48z',
                79:'-30x106y-278z',
                80:'-317x175y-168z',
                81:'-31x287y-80z',
                82:'-35x101y-279z',
                83:'-37x209y-211z',
                84:'-38x0y-297z',
                85:'-39x97y-280z',
                86:'-41x1y-297z',
                87:'-43x92y-282z',
                88:'-44x3y-296z',
                89:'-46x284y-83z',
                90:'-46x6y-296z',
                91:'-47x205y-213z',
                92:'-47x87y-283z',
                93:'-49x9y-295z',
                94:'-50x285y-78z',
                95:'-50x82y-284z',
                96:'-51x12y-295z',
                97:'-52x77y-284z',
                98:'-53x16y-294z',
                99:'-55x19y-294z',
                100:'-55x72y-285z',
                101:'-56x67y-286z',
                102:'-57x200y-215z',
                103:'-57x23y-293z',
                104:'-58x28y-292z',
                105:'-58x62y-287z',
                106:'-59x32y-292z',
                107:'-59x56y-288z',
                108:'-60x37y-291z',
                109:'-60x41y-290z',
                110:'-60x46y-290z',
                111:'-60x51y-289z',
                112:'-61x280y-86z',
                113:'-65x281y-81z',
                114:'-67x194y-217z',
                115:'-75x276y-89z',
                116:'-76x189y-219z',
                117:'-79x276y-84z',
                118:'-85x182y-221z',
                119:'-89x271y-92z',
                120:'-8x121y-274z',
                121:'-93x176y-223z',
                122:'-93x271y-87z'}

#"
#/>


# -------------------------------------------------------------------------------------------------------------------
#<function4xi function = "fire300six4xi" usage = "target function for charge2six4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------------------------
def fire300six4xi(queue2six, consumer_channel2six, publisher_channel2six):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE300SIX4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE300SIX4XI -  QUEUE2SIX: ", queue2six)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE300SIX4XI -  CONSUMER_CHANNEL2SIX: ", consumer_channel2six)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE300SIX4XI -  PUBLISHER_CHANNEL2SIX: ", publisher_channel2six)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE300SIX4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2SIX: ", queue2six, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2six.put(shot2six3004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE300SIX4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2SIX: ", queue2six, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE300SIX4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2SIX: ", queue2six, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE300SIX4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2SIX: ", publisher_channel2six, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2six8shot2six300x4xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2six8shot2six300x4xi</nack2put4xi>" 
            
        publisher_channel2six.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE300SIX4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2SIX: ", publisher_channel2six, " - TIME: ", time4xi()) 
            # 
        
    except:
        print(" (STEP 3C/33) OF FIRE300SIX4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2SIX: ", publisher_channel2six, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE300SIX4XI - RETURNING QUEUE OBJECT QUEUE2SIX: ", queue2six, " - TIME: ", time4xi())  
        # 
            
    return queue2six    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire300six4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
